<template>
  <crud-data-table
    :items="categories"
    :headers="headers"
    :loading="isLoading"
    :search-placeholder="$t('global.crudDataTable.action.searchByTitlePlaceholder')"
    :no-data-message="$t('noDataText')"
  >
    <template v-slot:create>
      <create-category-dialog />
    </template>

    <template v-slot:confirmationToDelete>
      <delete-category-dialog @onDeleteCategory="onDeleteCategoryCallback = $event" />
    </template>

    <template v-slot:title="props">
      <edit-title-dialog
        v-model="props.item.title"
        :item-id="props.item.id"
      />
    </template>

    <template v-slot:count="{ item: { count } }">
      {{ $t('global.crudDataTable.body.countText', { n: count }) }}
    </template>

    <template v-slot:createdAt="{ item: { createdAt } }">
      {{ createdAt | formatDateToRelativeTime }}
    </template>

    <template v-slot:updatedAt="{ item: { updatedAt } }">
      {{ updatedAt | formatDateToRelativeTime }}
    </template>

    <template v-slot:delete="{ item }">
      <v-btn
        icon
        @click="onDeleteCategoryCallback(item)"
      >
        <v-icon>
          mdi-trash-can-outline
        </v-icon>
      </v-btn>
    </template>
  </crud-data-table>
</template>

<script>
  import DatesMixin from '@/mixins/date'
  import getTableHeaders from './table-headers'
  import { get } from 'vuex-pathify'
  // components
  import EditTitleDialog from './components/crud/Update.vue'
  import DeleteCategoryDialog from './components/crud/Delete.vue'
  import CreateCategoryDialog from './components/crud/Create.vue'

  export default {
    name: 'CategoriesView',
    components: {
      EditTitleDialog,
      DeleteCategoryDialog,
      CreateCategoryDialog,
    },
    mixins: [DatesMixin],
    data () {
      return {
        search: '',
        onDeleteCategoryCallback: null,
        headers: getTableHeaders(key => this.$t(key)),
      }
    },
    computed: {
      ...get('categories', [
        'categories',
        'isLoading',
      ]),
    },
    i18n: {
      messages: {
        'pt-BR': {
          noDataText: 'Nenhuma categoria cadastrada.',
        },
        'en-US': {
          noDataText: 'No categories registered.',
        },
      },
    },
  }
</script>
